#!/usr/bin/perl
###########################
##  AutoRank Pro v3.0.0  ##
##################################################
##  search.cgi - search the database            ##
##################################################

package srch;

use strict;
#push(@INC, 'c:/full/path/to/cgi/scripts');       ## NT support - uncomment and fill in correct path if necessary.

my $DDIR = './data';
my $TDIR = './templates';
my(%TPL, %QRY);

print "Content-type: text/html\n\n";

eval {
  require "$DDIR/vars.dat";
  require "$DDIR/search.cgi";
  main();
};

err("$@", 'search.cgi') if( $@ );
exit;

#################################################################################
##  Removing any code from this file which creates the link back to CGI Works  ##
##  is a copyright violation.  If your site is found to have removed the link  ##
##  your software license will be terminated and the proper authorities will   ##
##  be contacted.  Do not remove any code that creates the link to CGI Works.  ##
#################################################################################

sub main {
  parseget();

  derr(1001, "No Search Term Entered") if($QRY{'key'} eq '' || $QRY{'key'} =~ /^\s+$/);

  my $total = 0;

  print $HTML::HEAD;

  open(SRCH, "$DDIR/dbs/search") || err($!, 'search');
  while( <SRCH> ) {
    my @md = split(/\|/, $_);

    if( $QRY{'cat'} eq 'Overall' || $md[2] eq $QRY{'cat'} ) {
      if( $md[1] =~ /$QRY{'key'}/i || $md[4] =~ /$QRY{'key'}/i ) {
        $TPL{'TITLE'} = $md[1];
        $TPL{'DESC'}  = $md[4];
        $TPL{'URL'}   = $OPT::OUT ? $VAR::OU . "?id=$md[0]&url=" . urlencode($md[3]) : $md[3];
        $TPL{'CAT'}   = $md[2];

        vparse($HTML::TEMP);
        $total++;
      }
    }
  }
  close(SRCH);

  $TPL{'TOT'} = $total;
  $TPL{'KEY'} = $QRY{'key'};
  vparse($HTML::FOOT);
}

sub urlencode {
  my $url = shift;
  $url =~ s/([^\w\.\-])/sprintf("%s%x", '%', ord($1))/eg;
  return $url;
}

sub vparse {
  my($html, $fh) = @_;
  $fh = *STDOUT if(!$fh);
  $html =~ s/#%(.*?)%#/$TPL{$1}/gise;
  print $fh $html;
}

sub freadalls {
  my($file, $line) = shift;
  open(FILE, $file) || err($!, $file);
  flock(FILE, 1);
  while( <FILE> ) {
    $line .= $_;
  }
  close(FILE);
  return \$line;
}

sub geticons {
  my($ico, $html) = shift;
  for( split(/,/, $ico) ) {
    next if( $_ eq '' || (!-e "$DDIR/icons/$_"));
    $html .= ${ freadalls("$DDIR/icons/$_") } . '&nbsp;';
    $html =~ s/\n&nbsp;/&nbsp;/g;
  }
  $html =~ s/&nbsp;$//g;
  return $html;
}

sub getmem {
  my $id = shift;
  $id =~ s/\..+$//;
  return $id;
}

sub fsplit {
  my($file) = shift;
  open(FILE, "$file") || err($!, $file);
  flock(FILE, 1);
  my @data = split(/\|/, <FILE>);
  close(FILE);

  return \@data;
}

sub dread {
  my($dir, $patt) = @_;
  opendir(DIR, $dir) || err($!, $dir);
  my @files = grep { /$patt/ } sort readdir(DIR);
  closedir(DIR);

  return \@files;
}

sub parseget {
  my @pairs = split(/&/, $ENV{'QUERY_STRING'});
  my ($name, $value);
  
  for (@pairs) {
    ($name, $value) = split(/=/, $_);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $QRY{$name} = $value;
  }
}

sub fparse {
  my($page, $fh, $line) = @_;  
  $fh = *STDOUT if(!$fh);

  open(FILE, "$TDIR/$page") || err($!, $page);
  while( $line = <FILE> ) {
    $line =~ s/#%(.*?)%#/$TPL{$1}/gise;
    print $fh $line;
  }
  close(FILE);
}

sub derr {
  my($num, $data) = @_;

  eval {
    require "$DDIR/errors.dat";
  };
  
  err("$@", 'errors.dat') if( $@ );
  $TPL{'SERR'}  = "Data Error: $data";
  $TPL{'LERR'}  = $err::code{$num};
  fparse('_error_data.htmlt');

  exit -1;
}

sub err {
  my($cause, $file) = @_;
  my @from = caller(1);
  chomp($cause);

  print "<pre>\n";
  print "A CGI ERROR HAS OCCURRED\n========================\n";
  print "Error Message     :  $cause\n";   
  print "Accessing File    :  $file\n";
  print "Calling Function  :  $from[3] from $from[1]" if( $from[3] ne "" );
  exit;
}