#!/usr/bin/perl
###########################
##  AutoRank Pro v3.0.x  ##
##################################################
##  sort.pl - AutoRank Pro sorting functions    ##
##################################################

package srt;

use lib '.';                                      ## You may need to set this to the full path to cgiworks.pm
use strict;
use cgiworks;
use vars qw(@sort %mem %cats $filter $tot);

$tot = 0;
$filter = 1;
for( split(/,/, $VAR::CT) ) { $cats{$_} = 0; }

1;

#################################################################################
##  Removing any code from this file which creates the link back to CGI Works  ##
##  is a copyright violation.  If your site is found to have removed the link  ##
##  your software license will be terminated and the proper authorities will   ##
##  be contacted.  Do not remove any code that creates the link to CGI Works.  ##
#################################################################################

sub bycount {
  my( $key, $wt, $cat ) = @_;

  for( @{ dread("$DDIR/members", '\.cnt$') } ) {
    $tot++;
    my $cd  = fsplit("$DDIR/members/$_");
    my $val = $wt ? int($cd->[$key] * $cd->[5]) : $cd->[$key];
    if( int($cd->[7]) ) {
      next if( $filter );
      $val = -1;
    }
    next if( $filter && $val < $VAR::MH );

    $mem{$_} = $val . '|' . join('|', @{ $cd }) if( $cat eq 'Overall' || $cd->[6] eq $cat );
    $cats{$cd->[6]}++ if( $cats{$cd->[6]} < $VAR::CL );
  }

  @sort = sort { $mem{$srt::b} <=> $mem{$srt::a} } keys %mem;
}

sub byaverage {
  my( $key, $wt, $len, $cat ) = @_;

  for( @{ dread("$DDIR/members", '\.cnt$') } ) {
    $tot++;
    my $cd  = fsplit("$DDIR/members/$_");
    my $val = $wt ? int($cd->[$key] * $cd->[5]) : $cd->[$key];
    if( int($cd->[7]) ) {
      next if( $filter );
      $val = -1;
    }
    
    my $age = time - $cd->[8];
    my $avg = getavg($val, $age, $len);
    next if( $filter && $avg < $VAR::MH );

    $mem{$_} = $avg . '|' . join('|', @{ $cd }) if( $cat eq 'Overall' || $cd->[6] eq $cat ); 
    $cats{$cd->[6]}++ if( $cats{$cd->[6]} < $VAR::CL );
  }

  @sort = sort { $mem{$srt::b} <=> $mem{$srt::a} } keys %mem;
}

sub byid {
  my $cat = shift;
  $TPL{'STBY'} = "Username";
  for( @{ dread("$DDIR/members", '\.cnt$') } ) {
    my $md  = fsplit("$DDIR/members/$_");
    $mem{$_} = arp::getmem($_) if( $cat eq 'Overall' || $md->[6] eq $cat ); 
  }
  @sort = sort { $mem{$srt::b} <=> $mem{$srt::a} } keys %mem;
}

sub byact {
  my $cat = shift;
  $TPL{'STBY'} = "Inactivity";
  for( @{ dread("$DDIR/members", '\.dat$') } ) {
    my $md  = fsplit("$DDIR/members/$_");
    $mem{$_} = $md->[22] if( $cat eq 'Overall' || $md->[8] eq $cat ); 
  }

  @sort = sort { $mem{$srt::b} <=> $mem{$srt::a} } keys %mem;
}

sub byin {
  $TPL{'STBY'} = "Hits In";
  bycount(0, 1, shift);
}

sub byout {
  $TPL{'STBY'} = "Hits Out";
  bycount(1, 0, shift);
}

sub bytin {
  $TPL{'STBY'} = "Total Hits In";
  bycount(2, 1, shift);
}

sub bytout {
  $TPL{'STBY'} = "Total Hits Out";
  bycount(3, 0, shift);
}

sub bydate {
  $TPL{'STBY'} = "Signup Date";
  bycount(8, 0, shift);
}

sub byidav {
  $TPL{'STBY'} = "Hits In/Day";
  byaverage(2, 1, 86400, shift);
}

sub byiwav {
  $TPL{'STBY'} = "Hits In/Week";
  byaverage(2, 1, 604800, shift);
}

sub byimav {
  $TPL{'STBY'} = "Hits In/Month";
  byaverage(2, 1, 2592000, shift);
}

sub byodav {
  $TPL{'STBY'} = "Hits Out/Day";
  byaverage(3, 0, 86400, shift);
}

sub byowav {
  $TPL{'STBY'} = "Hits Out/Week";
  byaverage(3, 0, 604800, shift);
}

sub byomav {
  $TPL{'STBY'} = "Hits Out/Month";
  byaverage(3, 0, 2592000, shift);
}

sub getavg {
  my( $cnt, $age, $len ) = @_;
  return sprintf("%.$VAR::DP" . "f", $age >= $len ? $cnt / ($age / $len) : $cnt);
}